//
// Created by Administrator on 2019/1/17.
// 共用数据 如工作工作面 地图等
//

#ifndef WORKSPACE_WORKFACE_DATA_H
#define WORKSPACE_WORKFACE_DATA_H

#include <string>
#include <map>
#include <memory>
#include "struct_def.h"

struct WorkfaceDBData
{
    int workface_id;
    int workface_type;
    std::string workface_name;
    int map_id;
    int area_id;
    std::string lastUpdateTime;
    WorkfaceDBData()
    {
        workface_id = 0;
        workface_type= 0;
        workface_name ="";
        map_id = 0;
        area_id = 0;
        lastUpdateTime = "";
    }
};

class common_data
{
public:
    common_data();
    ~common_data();

public:
    void init_data();

    /*根据卡ID获取工作面ID
        * return -1 : 表示不存在
        * */
    int get_workface_id(std::string card_id);

    /*根据卡ID获取车ID
     * return -1 : 表示不存在
     * */
    int get_vechicle_id(std::string card_id);

    /*根据车ID获取卡ID
    * return "" : 表示不存在
    * */
    std::string get_card_id(int vechicle_id);

    /*获取工作面的DB数据* */
    std::shared_ptr<WorkfaceDBData> get_workface(int work_face_id);

    /*设置当前的地图ID*/
    void set_map_id(int map_id);
private:
    /*初始化工作面*/
    int init_data_workface();
    /*初始化车卡对应车卡ID*/
    int init_data_bind_card_vechicle();
    /*初始化车卡对应工作面	*/
    int init_data_bind_card_workface();
    /*初始化地图*/
    void init_data_map();
public:
    typedef std::map<std::string, int> CardVehicleMap;  // 卡ID对应车ID 对应表
    typedef std::map<std::string, int> CardWorkfaceMap; // 车卡和工作面对应表
    typedef std::map<int,std::string>  VehicleCardMap;  // 车ID对应卡号
    CardVehicleMap  m_card_vehicle;  // 车卡对应车ID
    CardWorkfaceMap m_card_workface; // 车卡对应工作面
    VehicleCardMap  m_vehicle_card;  // 车ID 对应卡ID

    typedef std::map<int ,std::shared_ptr<WorkfaceDBData>> WorkfaceMap;
    WorkfaceMap m_workface;

    //地图缩放信息
    typedef std::map<int,map_info> MAP_MAP_INFO;
    MAP_MAP_INFO m_map_list;

    //当前使用的地图
    int m_cur_map_id;
    //地图缩放比例
    double m_map_scale;
};


#endif //WORKSPACE_WORKFACE_DATA_H
