#ifndef REGULARCYCLE_RATE_H
#define REGULARCYCLE_RATE_H
#include "tr_tool.h"
#include <memory>
		

class regularcycle_rate
{
public:
	regularcycle_rate();
	~regularcycle_rate(){};
	/*
	* 初始化参数
	*/
	void init();
	/*初始化采煤机有关正规循环率计算的先前参数
	* param
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int init_data_pre_coalmining_RegularCycle();
	/*初始化半刀未完成的正规循环率情况
	* param
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int init_restart_halfcoalmining_regularcycle();
	/*初始化采煤机有关正规循环率计算的中间参数
	* param
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int init_data_coalmining_RegularCycle(const std::string& face_id = "-1");
	void remove_data_coalmining_RegularCycle(int face_id);
	/*初始化综采面有关正规循环率计算的参数	
	* param
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int init_data_coalminingface_RegularCycle(const std::string& face_id = "-1");
	void remove_data_coalminingface_RegularCycle(int face_id);
	/*获取采煤机的计划刀数
	* param
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int get_data_coalmining_scheduletimes(int workface_id,double& scheduletimes);
	/* 完成半刀，更新刀数值为0.5
	* param
	*		reguilarCycle	---		采煤机0.5刀的参数
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int update_halfknife_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );
	/*存储采煤机完成1刀的情况
	* param
	*		reguilarCycle	---		采煤机1刀的参数
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int Update_data_coalmining_Regular_cycle ( std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );
	/*存储挖煤机前半刀开始数据
	* param
	*		reguilarCycle	---		采煤机1刀的参数
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int store_halfknife_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );
	/*存储采煤机1刀开始的情况
	* param
	*		reguilarCycle	---		采煤机1刀的参数
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int store_data_coalmining_Regular_cycle ( std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );
	/*发送采煤机距离固定点距离（现在设置为机头）
	* param
	*		vehicle_id	---		车ID
	*		dis_record		---		过去一分钟记录的位置
	* return
	*		函数正常执行返回0，否则返回1
	*/
	int store_data_coalmining_Pos(int workface_id, double dis_record);
	/*计算采煤机的正规循环率
	* param
	*		card	---		车卡信息
	* return
	*/
	void Calc_CoalMining_RegularCycleRate ( std::shared_ptr<coaldrivingface_card> card);
	
private:
	CoalMiningRegularCycleMap m_coalmining_regularcycle_list;//挖煤机正规循环率计算中间值
	CoalMiningAreaMap m_coalmining_area_list;//综采面计算挖煤机正规循环率的参数
};
#endif
