#ifndef THREE_RATES_H
#define THREE_RATES_H
#include "struct_def.h"
#include"memory"

class three_rates
{ 
public:
    // Constructor
    three_rates(){}
    // Destructor
    virtual ~three_rates(){}
    /*
    * Functon:    Init the three_rates module
    * Parameters: 
    *             init_param& para - in&out, three_rates parameters
    * Returns:    void
    * Throws:     void
     */
    virtual void init(const init_para& para, const  db_para& dpara ) = 0;
    /*
    * Functon:    Start the three_rates module
    * Parameters: void
    * Returns:    void
    * Throws:     void
     */
    virtual void start() = 0;
    /*
    * Functon:    Stop the three_rates module
    * Parameters: void
    * Returns:    void
    * Throws:     void
     */
    virtual void stop() = 0;
    /*
    * Functon:    Input the located datas
    * Parameters: 
    *             card_pos& pos - in, position informations
    * Returns:    void
    * Throws:     void
     */
    virtual void put(const card_pos& pos) = 0;
    /*
    * Functon:    Enter one area
    * Parameters: 
    *             card_pos& pos   - in, the located datas
    *             area_data& area - in, the area informations
    * Returns:    void
    * Throws:     void
     */
    virtual void enter_area(std::shared_ptr<card_pos> &card_ptr, std::shared_ptr<area_data> &area_ptr) = 0;
    /*
    * Functon:    Leave one area
    * Parameters: 
    *             card_pos& pos   - in, the located datas
    *             area_data& area - in, the area informations
    * Returns:    void
    * Throws:     void
     */
    virtual void leave_area(std::shared_ptr<card_pos> &card_ptr, std::shared_ptr<area_data> &area_ptr) = 0;

    /*
     *  获取掘进机或者采煤机的开机状态
     */
    virtual bool GetVehicleState(int vehicleId) = 0;
	/*
   * Functon:    WEB通知数据有更新
   * Parameters:
   *             std::string webname,    - in, 更新表名
   *             std::string param - in, 更新表内容（id）
   * Returns:    void
   * Throws:     void
	*/
	virtual void update_db_data(const std::string& webname, const std::string& param, int edit_type_id)=0;
    static three_rates* get_instance();
};





#endif
